/*  ___   ___  ___  _   _  ___   ___   ____ ___  ____  
 * / _ \ /___)/ _ \| | | |/ _ \ / _ \ / ___) _ \|    \ 
 *| |_| |___ | |_| | |_| | |_| | |_| ( (__| |_| | | | |
 * \___/(___/ \___/ \__  |\___/ \___(_)____)___/|_|_|_|
 *                  (____/ 
 * Osoyoo Wifi Smart Home V2.0 Lesson 3-1
 * 
 * tutorial url: https://osoyoo.com/?p=40234
 */
#define BLYNK_PRINT Serial
#include <BlynkSimpleShieldEsp8266.h>
#include <ESP8266_Lib.h>
char auth[] = "0ByWpc50cmOJ5O6OyHMaK4OSHkDvUeI-";//replace this with your Blynk Token
char server_ip[]="192.168.1.81"; // replace this line with your Blynk Server IP address
// Your WiFi credentials.
// Set password to "" for open networks.
char ssid[] = "***";//replace this line with your wifi ssid
char pass[] = "***"; //replace this line with your wifi password
#include <SoftwareSerial.h>
SoftwareSerial EspSerial(A9, A8); // RX, TX
ESP8266 wifi(&EspSerial);

SimpleTimer timer;
int Buzzer = 7;//the pin of the active buzzer
//PIR_HC_SR501
int pir_hc_sr501 = 6;          // choose the pin for the PIR
int pirState = LOW;             // we start, assuming no motion detected
int pirval = 0;                    // variable for reading the pin status
 
void PIRSENSOR () {
    Serial.println("PIR SENSOR START!");
    pirval = digitalRead(pir_hc_sr501);  // read input value
    if (pirval == HIGH) {            // check if the input is HIGH
    digitalWrite(Buzzer, HIGH);
    if (pirState == LOW) {
    // we have just turned on
    Serial.println("Motion detected!");
    // We only want to print on the output change, not state
    pirState = HIGH;
  
    Blynk.notify("Someone broke in!");
    }
  } 
  else 
  {
    if (pirState == HIGH){
    // we have just turned of
    digitalWrite(Buzzer, LOW);
    Serial.println("Motion ended!");
    // We only want to print on the output change, not state
    pirState = LOW;
    }
  }
}

void setup()
{
  // Debug console
  Serial.begin(9600);
 while (!Serial) {
    ; // wait for serial port to connect. Needed for native USB port only
  }
  Serial.println("start");
  // set the data rate for the SoftwareSerial port
  EspSerial.begin(115200);
  EspSerial.write("AT+UART_DEF=9600,8,1,0,0\r\n");
  EspSerial.write("AT+RST\r\n");
  delay(100);
  EspSerial.begin(9600);
  Blynk.begin(auth, wifi, ssid, pass,server_ip,8080);
  timer.setInterval(2500L, PIRSENSOR);
}

void loop()
{
  Blynk.run();
  timer.run();
  }
